export type TVariable<Name extends string = string, Value extends (string | null) = string> = {
    name: Name;
    value: Value;
};
export type TTemplateVariable<Name extends string = string> = TVariable<Name, null>;
export type TResolverVariable<Name extends string = string, Value extends string = string> = TVariable<Name, Value>;
export type TExtractVarName<Var> = Var extends `{${infer VarName}=${string}}` ? VarName : Var extends `{${infer VarName}}` ? VarName : `Var is not a variable`;
export type TTemplateVarString<VarName> = VarName extends string ? `{${VarName}}` : `TTemplateVarString, Name is not a string`;
export type TResolverVarString<VarName, VarValue> = VarName extends string ? VarValue extends string ? `{${VarName}=${VarValue}}` : `TResolverVarString, Value is not a string` : `TResolverVarString, Name is not a string`;
declare class VariableBase {
    static readonly SEGMENT_JOIN_CHAR = ".";
    constructor();
    toResolverSegment(variable: TVariable<string, string>): string;
    toTemplateSegment(variable: TVariable<string, null | string>): string;
}
export declare const Variable: VariableBase;
export {};
